org.apache.sysds.runtime.compress.bitmap

## Class MultiColBitmap

- java.lang.Object
- - org.apache.sysds.runtime.compress.bitmap.ABitmap
  - - org.apache.sysds.runtime.compress.bitmap.MultiColBitmap

    public final class MultiColBitmap
    extends ABitmap

Uncompressed representation of one or more columns in bitmap format.

### Method Summary

All Methods Instance Methods Concrete Methods
`int` `getNumColumns()`
`int` `getNumNonZerosInOffset(int idx)`
`int` `getNumValues()` Obtain number of distinct value groups in the column.
`double[][]` `getValues()` Get all values without unnecessary allocations and copies.
`double[]` `getValues(int ix)` Obtain tuple of column values associated with index.
`void` `sortValuesByFrequency()`

### Methods inherited from class org.apache.sysds.runtime.compress.bitmap.ABitmap

`containsZero, getNumOffsets, getNumOffsets, getNumZeros, getOffsetList, getOffsetsList, isEmpty, toString`

### Methods inherited from class java.lang.Object

`equals, getClass, hashCode, notify, notifyAll, wait, wait, wait`

### Method Detail

#### getValues

    public double[][] getValues()

Get all values without unnecessary allocations and copies.

Returns:
  dictionary of value tuples

#### getValues

    public double[] getValues(int ix)

Obtain tuple of column values associated with index.

Parameters:
  `ix` - index of a particular distinct value
Returns:
  the tuple of column values associated with the specified index

#### getNumNonZerosInOffset

    public int getNumNonZerosInOffset(int idx)

Specified by:
  `getNumNonZerosInOffset` in class `ABitmap`

#### getNumValues

    public int getNumValues()

Description copied from class: `ABitmap`
Obtain number of distinct value groups in the column. this number is also the number of bitmaps, since there is one bitmap per value

Specified by:
  `getNumValues` in class `ABitmap`
Returns:
  number of distinct value groups in the column;

#### sortValuesByFrequency

    public void sortValuesByFrequency()

Specified by:
  `sortValuesByFrequency` in class `ABitmap`

#### getNumColumns

    public int getNumColumns()

Specified by:
  `getNumColumns` in class `ABitmap`